rollout CreateTxtVolume "Create volume txt file" width:160 height:120
(
	--this is from maxscript helpfile
	fn CalculateVolumeAndCenterOfMass obj = 
	( 
	Volume= 0.0 
	Center= [0.0, 0.0, 0.0] 
	theMesh = snapshotasmesh obj
	numFaces = theMesh.numfaces 
	for i = 1 to numFaces do 
	( 
	Face= getFace theMesh i 
	vert2 = getVert theMesh Face.z 
	vert1 = getVert theMesh Face.y 
	vert0 = getVert theMesh Face.x 
	dV = Dot (Cross (vert1 - vert0) (vert2 - vert0)) vert0
	Volume+= dV 
	Center+= (vert0 + vert1 + vert2) * dV 
	) 
	delete theMesh
	Volume /= 6 
	Center /= 24 
	Center /= Volume 
	#(Volume,Center) 
	)
	
	button btn2 "Create txt from scene" pos:[8,8] width:143 height:33
	button btn3 "Create txt from selected" pos:[8,48] width:143 height:33
	label lbl2 "By Anton Berg OS3D.se" pos:[8,96] width:144 height:16
	
	on btn2 pressed do
	(
	CtvPath = getSaveFileName caption:"Save txt file as:" filename:"c:/test/test.txt" types:"Text(*.txt)|*.txt|All|*.*|"
		if CtvPath != undefined then
		(
		btn2.caption = filenameFromPath CtvPath
		CtvSelection = $* as array
		out_file = createfile CtvPath
		
		for item in CtvSelection do 
		(

		try(
		format "Name:\t%\tVolume:\t%\n" item.name  (CalculateVolumeAndCenterOfMass item)[1] to:out_file
			)
		catch(
			format "Name:\t%\tHas no volume, or cant be calculated\n" item.name to:out_file
			)
		)
		close out_file
		messageBox("Txtfile creation finished!")
		)
		else
		(
		messageBox ("No ouput txt set")
		btn2.caption = "No ouput file set"
		)
	)
	on btn3 pressed do
	(
		CtvPath2 = getSaveFileName caption:"Save txt file as:" filename:"c:/test/test.txt" types:"Text(*.txt)|*.txt|All|*.*|"
		if CtvPath2 != undefined then
		(
		btn3.caption = filenameFromPath CtvPath2
		CtvSelection = selection as array --create array from selected objects
		out_file2 = createfile CtvPath2
		
		for item in CtvSelection do 
		(

		try(
		format "Name:\t%\tVolume:\t%\n" item.name  (CalculateVolumeAndCenterOfMass item)[1] to:out_file2
			)
		catch(
			format "Name:\t%\tHas no volume, or cant be calculated\n" item.name to:out_file2
			)
		)
		close out_file2
		messageBox("Txtfile creation finished!")
		)
		else
		(
		messageBox ("No ouput txt set")
		btn3.caption = "No ouput file set"
		)
	)

)createDialog CreateTxtVolume
